<?php

namespace app\Traits;

use Exception;
use Image;

trait FileTrait
{
    public static function picUrl($pic, $imgType, $platform)
    {
        $avatarUrl = config('constants.baseUrl') . config('constants.avatar');
        $avatar = 'no_image.png';
        if ($imgType == 'adminPic') {
            $url = config('constants.baseUrl') . config('constants.adminPic');
            $avatar = 'admin_avatar.png';
        } else if ($imgType == 'userPic') {
            $url = config('constants.baseUrl') .'public/'. config('constants.userPic');
            $avatar = 'user_avatar.png';
        } else if ($imgType == 'bannerPic') {
            $url = config('constants.baseUrl') . config('constants.bannerPic');
            $avatar = 'no_image.png';       
        }  
           else {
            $avatarUrl = config('constants.baseUrl') . config('constants.avatar');
            $avatar = 'no_image.png';
        }

        if ($pic != 'NA') {
            if (strpos($pic, 'https') !== false) {
                $picture = $pic;
            } else {
                $picture = $url . $pic;
            }
        } else {
            if ($platform == 'backend') {
                if($imgType=='resumePic') {
                    $picture = 'NA';
                }
                
                else
                {
                    $picture = $avatarUrl . $avatar;
                }
            } elseif ($platform == 'web') {
                if($imgType=='resumePic') {
                    $picture = 'NA';
                }
                
                else
                {
                    $picture = $avatarUrl . $avatar;
                }
            } else {
                $picture = 'NA';
            }
        }

        return $picture;
    }



    
    public function uploadPicture($image, $previousImg, $platform, $imgType,$docExtension)
    {
        try {
            $image = $image;
            $docExtension = $docExtension;
            //$input['imagename'] = md5($image->getClientOriginalName() . microtime()) . "." . $image->getClientOriginalExtension();
            
            if ($platform == 'backend') {
                $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.' . $image->getClientOriginalExtension();
                if ($imgType == 'adminPic') {
                    $largeWidth = '200';
                    $largeHeight = '200';
                    $largePicPath = config('constants.adminPic');
                    $smallPicPath = '';
                    Image::make($image->getRealPath())->resize($largeWidth, $largeHeight)->save($largePicPath . $input['imagename']);
                } elseif ($imgType == 'themePic') {
                    $largePicPath = config('constants.themePic');
                    $smallPicPath = '';

                    $image->move($largePicPath, $input['imagename']);

                    // $largeWidth = '640';
                    // $largeHeight = '240';
                    // Image::make($image->getRealPath())->resize($largeWidth, $largeHeight)->save($largePicPath . $input['imagename']);
                }   elseif ($imgType == 'bannerPic') {
                    $largePicPath = config('constants.bannerPic');
                    $smallPicPath = '';


                    $image->move($largePicPath, $input['imagename']);

                    
                }  elseif ($imgType == 'favIconPic') {
                    $largePicPath = config('constants.favIconPic');
                    $smallPicPath = '';
                    $image->move($largePicPath, $input['imagename']);
                }  else {
                }
            } elseif ($platform == 'web') {
                //
            } elseif($platform == 'app') {
               
               

                if($imgType=='userPic')
                {   
                    $img = str_replace(' ', '+', $image);
                    $image = base64_decode($img);
                    $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.png';                             
                    $largePicPath = config('constants.userPic');
                    $smallPicPath = '';
                    $file = $largePicPath . $input['imagename'];
                    $success = file_put_contents($file, $image);
                }          
                

            
                //  $image->move($largePicPath, $input['imagename']);

            }

            if(!empty($largePicPath))
            {    
                // $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.png';
                if(!file_exists($largePicPath . $input['imagename']))
                {
                    return false;
                }
            }

            if(!empty($smallPicPath))
            {    
                // $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.png';
                if(!file_exists($largePicPath . $input['imagename']))
                {
                    return false;
                }
            }


            if (!empty($previousImg)) {
                if($imgType=='cvDoc')
                {
                    // $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.docx';
                    if ($previousImg == 'NA') {
                        return $file_name;
                    } else {
                        if (unlink($uploadDir . $previousImg)) {
                            if ($smallPicPath != '') {
                                unlink($smallPicPath . $previousImg);
                            }
                            return $file_name;
                        } else {
                            return false;
                        }
                    }
                }
                else
                {
                    // $input['imagename'] = time() . '_' . mt_rand() . '_' . mt_rand() . '.png';
                    if ($previousImg == 'NA') {
                        return $input['imagename'];
                    } else {
                      
                        if (unlink($largePicPath . $previousImg)) {
                            if ($smallPicPath != '') {
                                unlink($smallPicPath . $previousImg);
                            }
                            return $input['imagename'];
                        } else {
                            return false;
                        }
                    } 
                }
               
            }
            else {
                if($imgType=='cvDoc')
                { 
                    return $file_name;
                }
                else
                {
                   
                
                    return $input['imagename'];
                }
            }
        } catch (Exception $e) {
            return false;
        }
    }

    
}
